//+----------------------------------------------------------+
//|                                 Ehlers' fisher transform |
//|                                                   mladen |
//+----------------------------------------------------------+
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Green
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Red
#property  indicator_color5  DimGray
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2

//
//
//
//
//
 
extern int    period                   = 10;
extern int    PriceType                = PRICE_MEDIAN;
extern bool   HistogramOnSlope         = true;

extern bool   alertsOn                 = true;
extern bool   alertsOnSlope            = true;
extern bool   alertsOnZeroCross        = true;
extern bool   alertsOnCurrent          = true;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsNotify             = false;
extern bool   alertsEmail              = false;

extern bool   arrowsVisible            = true;
extern string arrowsIdentifier         = "eft arrows1";
extern double arrowsUpperGap           = 1.0;
extern double arrowsLowerGap           = 1.0;

extern bool   arrowsOnSlope            = true;
extern color  arrowsOnSlopeUpColor     = LimeGreen;
extern color  arrowsOnSlopeDnColor     = Red;
extern int    arrowsOnSlopeUpCode      = 241;
extern int    arrowsOnSlopeDnCode      = 242;
extern int    arrowsOnSlopeSize        = 2;

extern bool   arrowsOnZeroCross        = false;
extern color  arrowsOnZeroCrossUpColor = DeepSkyBlue;
extern color  arrowsOnZeroCrossDnColor = PaleVioletRed;
extern int    arrowsOnZeroCrossUpCode  = 159;
extern int    arrowsOnZeroCrossDnCode  = 159;
extern int    arrowsOnZeroCrossSize    = 5;


//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double Prices[];
double Values[];
double trend[];
double slope[];

   
//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,buffer5);
      SetIndexBuffer(5,Prices);
      SetIndexBuffer(6,Values);
      SetIndexBuffer(7,trend);
      SetIndexBuffer(8,slope);
   IndicatorShortName("Ehlers\' Fisher transform ("+period+")");
   return(0);
}

int deinit()
{
   deleteArrows();

return(0);
}

//+----------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
         
   for(i=limit; i>=0; i--)
   {  
      Prices[i] = iMA(NULL,0,1,0,MODE_SMA,PriceType,i);
      
      //
      //
      //
      //
      //
                  
         double MaxH = Prices[ArrayMaximum(Prices,period,i)];
         double MinL = Prices[ArrayMinimum(Prices,period,i)];
         if (MaxH!=MinL)
               Values[i] = 0.33*2*((Prices[i]-MinL)/(MaxH-MinL)-0.5)+0.67*Values[i+1];
         else  Values[i] = 0.00;
               Values[i] = MathMin(MathMax(Values[i],-0.999),0.999); 
               buffer5[i] = 0.5*MathLog((1+Values[i])/(1-Values[i]))+0.5*buffer5[i+1];

      // 
      //
      //
      //
      //

         if(buffer5[i]==buffer5[i+1])
            {
               buffer1[i]=buffer1[i+1];
               buffer2[i]=buffer2[i+1];
               buffer3[i]=buffer3[i+1];
               buffer4[i]=buffer4[i+1];
               continue;
            }
      
         //
         //
         //
         //
         //
         
            buffer1[i]=EMPTY_VALUE;
            buffer2[i]=EMPTY_VALUE;
            buffer3[i]=EMPTY_VALUE;
            buffer4[i]=EMPTY_VALUE;
            trend[i]  = trend[i+1];
            slope[i]  = slope[i+1];
            if (buffer5[i] > 0)            trend[i] =  1;
            if (buffer5[i] < 0)            trend[i] = -1;
            if (buffer5[i] > buffer5[i+1]) slope[i] =  1;
            if (buffer5[i] < buffer5[i+1]) slope[i] = -1;
            
            if (HistogramOnSlope)
            {
              if (trend[i] ==  1 && slope[i] ==  1) buffer1[i] = buffer5[i];
              if (trend[i] ==  1 && slope[i] == -1) buffer2[i] = buffer5[i];
              if (trend[i] == -1 && slope[i] == -1) buffer3[i] = buffer5[i];
              if (trend[i] == -1 && slope[i] ==  1) buffer4[i] = buffer5[i];
            }
            else
            {                  
              if (trend[i] ==  1) buffer1[i] = buffer5[i];
              if (trend[i] == -1) buffer3[i] = buffer5[i];
            }
              manageArrow(i);
   }
manageAlerts();   
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow("1",0.5,i,arrowsOnSlopeUpColor,arrowsOnSlopeUpCode,arrowsOnSlopeSize,false);
         if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsOnSlopeDnColor,arrowsOnSlopeDnCode,arrowsOnSlopeSize, true);
      } 
      if (arrowsOnZeroCross && trend[i] != trend[i+1])
      {
         if (trend[i] == 1) drawArrow("2",1,i,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossSize,false);
         if (trend[i] ==-1) drawArrow("2",1,i,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossDnCode,arrowsOnZeroCrossSize, true);
      }                              
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert(time1,mess1,whichBar," Ehlers Fisher transform sloping up");
            if (slope[whichBar] ==-1) doAlert(time1,mess1,whichBar," Ehlers Fisher transform sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(time2,mess2,whichBar," Ehlers Fisher transform crossing zero up");
            if (trend[whichBar] ==-1) doAlert(time2,mess2,whichBar," Ehlers Fisher transform crossing zero down");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ehlers Fisher transform "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


